#version 330

layout(points) in;
layout(points) out;
layout(max_vertices = 30) out;
in vec3 gPosition[];
in vec3 gVelocity[];
in float gAge[];
in float gType[];
// 1 = emitter, 0 = normales partikel

out vec3 fPosition;
out vec3 fVelocity;
out float fAge;
out float fType;
uniform float elapsedTime;
#define TYPE_EMITTER 1.0f
#define TYPE_PARTICLE 0.0f

void main(){
    fAge = gAge[0] + elapsedTime;
    if(fAge < 0.5f){
        fPosition = gPosition[0] + (gVelocity[0] * elapsedTime);
        fVelocity = vec3(gVelocity[0].x, gVelocity[0].y, gVelocity[0].z - 0.1f);
        fType = TYPE_EMITTER;
        EmitVertex();
        EndPrimitive();
    }
}